unit UDMEnDrain;

interface

uses
  SysUtils, Classes, Dialogs, Forms, Controls;

const NumDat = 13;
      code_array: array[0..3] of string = ('Spa', 'Dis', 'Hyd', 'Con');

type
  DataSetR = array of real;
  LineSet  = array of string;

type
  TDMEnDrain = class(TDataModule)
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FileName, PathName, InputFileName: string;
    Title1, Title2 : string;
    Code, Method : string[3];
    Sign : string[4];
    DataR : DataSetR;
    Xdata, Ydata, Zdata : DataSetR;
    NrOfData : integer; 
    FileLine : LineSet;
    NrOfLines: Integer;
    procedure Read_InputFile;
    procedure Write_InputFile(const DocName: string);
    procedure read_output_lines(const DocName: string);
    procedure read_output_data(const DocName: string);
    procedure write_output_lines(const DocName: string);
    procedure program_error(const Warning: string);
    function Question(const Query: string): boolean;
  end;

var
  DMEnDrain: TDMEnDrain;

implementation

{$R *.dfm}


{******************************************************************************
 read/write input file
 ******************************************************************************}


procedure TDMEnDrain.Read_InputFile;
var  InFile: textfile;
     k: byte; Single : Char;
begin
  Assignfile(InFile, FileName);
  {$I-} Reset(InFile); {$I+}
  if ioresult <> 0 then
  begin
    Showmessage('The file "' + filename + '"could not be opened. It may be ' +
      'in use by another program,  or the'+
                ' programmer should incorporate more time.');
    exit;
  end;
  Readln(InFile, Title1);
  Readln(InFile, Title2);
  Readln(InFile);                   {skip filename}
  Read(InFile, Code, Single);
  Method:=Single;
  if (Code<>'Spa') and (Code<>'Hyd') and (Code<>'Dis') and (Code<>'Con')
  then  Program_error('The code in the inputfile "' + filename + '" is corrupt');
  Try readln (InFile,Method);
     Except on E: exception do Method:='Ene';
  end;
  Try for k := 1 to NumDat do
      begin
        SetLength (DataR,k);
        read(InFile, DataR[k-1]);
      end;
  Except on E: exception
      do    Program_error('Real numbers in the inputfile "' + filename +
                  '" are corrupt');
  end;
  Closefile(InFile);
end; {TDMEnDrain.Read_InputFile}



procedure TDMEnDrain.Write_InputFile(const DocName: string);
var  infile: textfile;
     k, Tail: byte;
begin
  Assignfile(InFile, DocName);
  {$I-} Rewrite(InFile); {$I+}
  if ioresult <> 0 then
  begin
    Showmessage('The file "' + DocName + '"could not be opened. It may be ' +
      'damaged, in use by another program,  or the'+
                ' programmer should incorporate more time.');
    exit;
  end;
  writeln(InFile, Title1);
  writeln(InFile, Title2);
  writeln(InFile, 'File Name: ' + DocName);
  writeln(InFile, Code,' ',Method);
//  if (Code<>'Spa') and (Code<>'Hyd') and (Code<>'Dis') and (Code<>'Con')
//  then  Program_error('The code in the inputfile "' + DocName + '" is corrupt');
  Try for k := 1 to NumDat do
  begin
    Tail:=3;
    if (k=1) and (Code<>'Dis') then Tail:=4;
    if (k=10) or (k=12) then Tail:=4;
    write(InFile,DataR[k-1]:10:Tail);
  end;
  Writeln(infile);
  Except on E: exception
      do    Program_error('Real numbers in the inputfile "' + DocName +
                  '" are corrupt');
  end;
  Closefile(infile);
end; {TDMEnDrain.Write_InputFile}


{******************************************************************************
 read/write output file
 ******************************************************************************}


procedure TDMEnDrain.read_output_lines(const DocName: string);
var  OutFile: textfile;
     k: integer;
begin
  AssignFile(OutFile,DocName);
  {$I-} Reset(OutFile); {$I+}
  if ioresult <> 0 then
  begin
    Showmessage('The file "' + DocName + '"could not be opened. It may be ' +
      'damaged, in use by another program,  or the'+
                ' programmer should incorporate more time.');
    exit;
  end;
  k:=0;
  while not eof(OutFile) do
  begin
    k:=k+1;
    SetLength (FileLine,k);
    readln(OutFile,FileLine[k-1]);
  end;
  NrOfLines:=k;
  Close(OutFile);
end; {TDMEnDrain.read_output_lines}


   {Nodig wanneer Graphics in Delphi worden opgnomen}

procedure TDMEnDrain.read_output_data(const DocName: string);
var  OutFile  : textfile;
     Detector : string;
     k        : integer;
begin
  AssignFile(OutFile,DocName);
  {$I-} Reset(OutFile); {$I+}
  if ioresult <> 0 then
  begin
    Showmessage('The file "' + DocName + '"could not be opened. It may be ' +
      'damaged,  in use by another program,,  or the'+
                ' programmer should incorporate more time.');
    exit;
  end;
  for k:=1 to 10 do readln (OutFile);
  readln (OutFile,Title1);
  while pos('  ',Title1)>0 do delete (Title1,Pos('  ',Title1),1);
  readln (OutFile,Title2);
  while pos('  ',Title2)>0 do delete (Title2,Pos('  ',Title2),1);
  for k:=1 to 4 do readln (OutFile);
  readln (OutFile,Sign);
  Detector := '';
  while not (Detector=' Output data:') do readln (OutFile,Detector);
  NrOfData := 0;
  while not (Detector=' #') do
  begin
    readln (OutFile,Detector);
    NrOfData:=NrOfData+1;
  end;
  NrOfData:=NrOfData-1;
  reset (OutFile);
  while not (Detector=' Output data:') do readln (OutFile,Detector);
  for k:=1 to NrOfData do
  begin
    Setlength(Xdata, k);
    Setlength(Ydata, k);
    Setlength(Zdata, k);
    readln(OutFile, Xdata[k-1], Ydata[k-1], Zdata[k-1], Zdata[k-1]);
  end;
  Close(OutFile);
end; {TDMEnDrain.read_output_data}



procedure TDMEnDrain.write_output_lines(const DocName: string);
var  OutFile: textfile;
     k: integer;
begin
  AssignFile(OutFile,DocName);
  {$I-} Rewrite(OutFile); {$I+}
  if ioresult <> 0 then
  begin
    Showmessage('The file "' + DocName + '"could not be opened. It may be ' +
      'damaged, in use by another program,  or the'+
                ' programmer should incorporate more time.');
    exit;
  end;
  for k:=1 to NrOfLines do
    writeln(OutFile,FileLine[k-1]);
  Close(OutFile);
end; {TDMEnDrain.write_output_lines}


{******************************************************************************
 Diverse routines
 ******************************************************************************}


procedure TDMEnDrain.program_error(const Warning: string);
begin Showmessage('A program error occurred.' + Warning);
      Application.Terminate;
end; {TDMEnDrain.program_error}



function TDMEnDrain.Question(const Query: string): boolean;
begin Result := MessageDlg(Query, mtConfirmation, [mbYes, mbNo], 0) = mrYes;
end; {TDMEnDrain.Question}



procedure TDMEnDrain.DataModuleCreate(Sender: TObject);
begin Filename := '';
end;


end.


