unit UEnDrainUtils;

interface

uses Dialogs, UDMEnDrain;

const                         {tbv graphics}
  PosX1=70;
  PosX2=PosX1+500;
  PosY1=70;
  PosY2=PosY1+320;

var
      {Input}
  CalcMethod,
  DataDir                : string;
  CalcDone               : boolean;
    {Graphics}
  Ymax, Ymin, Xmax, Xmin   : real;
  MaxY, MinY, MaxX, MinX   : longint;
  FactorY, FactorX,
  ScaleY, ScaleX, LX, LY, DecimY, DecimX: integer;
  RelXdata, RelYdata, RelZdata : array of integer;
  LegendX, LegendY, LegendY1, LegendY2, LegendZ : string;

     {Input}
  procedure CheckData(var DataOK: boolean);
    {Graphics}
  procedure Relative;
  procedure MaxMin;
  procedure Scaling;
  procedure Legends;

implementation

     {Input}

procedure CheckData(var DataOK: boolean);
{---------------------------------------}
var ii: byte;
    Comment: string;
begin
  Comment := (' Input not saved. Please correct the data');
  DataOk := false;
  for ii:=1 to NumDat do if DMEnDrain.DataR[ii-1]<0 then
    begin
      Showmessage ('Data cannot be negative.' + Comment);
      exit;
    end;
  if (DMEnDrain.Code<>'Con') and (DMEnDrain.DataR[2]<DMEnDrain.DataR[1]) then
  begin
    Showmessage('Take care that D2 is not less than D1.' + Comment);
    exit;
  end
  else
  if (DMEnDrain.Code<>'Con') and (DMEnDrain.DataR[1]<DMEnDrain.DataR[3]) then
  begin
    Showmessage('Take care that D1 is not less than Dw.' + Comment);
    exit;
  end
  else if (DMEnDrain.Code<>'Dis') and (DMEnDrain.Code<>'Con') and
          (DMEnDrain.DataR[7]<=DMEnDrain.DataR[0]) then
       begin
         Showmessage('Take care that Ka is greater than R.' + Comment);
         exit;
       end
  else if (DMEnDrain.Code<>'Spa') and  (DMEnDrain.Code<>'Con') and
          (DMEnDrain.DataR[12]<=2*DMEnDrain.DataR[6]) then
       begin
         Showmessage('Take care that S is larger than 2W.' + Comment);
         exit;
       end
  else if (DMEnDrain.Code='Dis') and
          (DMEnDrain.DataR[3]<=DMEnDrain.DataR[0]) then
       begin
         Showmessage('Take care that Dm is less than Dw.' + Comment);
         exit;
       end
  else if (DMEnDrain.Code='Spa') and
          (DMEnDrain.DataR[3]<=DMEnDrain.DataR[12]) then
       begin
         Showmessage('Take care that Dm is less than Dw.' + Comment);
         exit;
       end
  else if (DMEnDrain.Code='Con') and
          (DMEnDrain.DataR[1]<=DMEnDrain.DataR[3]) then
       begin
         Showmessage('Take care that Db is less than D2.' + Comment);
         exit;
       end
  else if (DMEnDrain.Code='Con') and
          (DMEnDrain.DataR[1]<=DMEnDrain.DataR[3]) then
       begin
         Showmessage('Take care that Db is larger than Dw.' + Comment);
         exit;
       end
  else if (DMEnDrain.Code='Con') and
          (DMEnDrain.DataR[3]<=DMEnDrain.DataR[6]) then
       begin
         Showmessage('Take care that Dm is less than Dw.' + Comment);
         exit;
       end
  else if (DMEnDrain.Code='Con') and
          (DMEnDrain.DataR[6]<=2*DMEnDrain.DataR[5]) then
       begin
         Showmessage('Take care that S is larger than 2W.' + Comment);
         exit;
       end
  else if (DMEnDrain.Code<>'Dis') and
          (DMEnDrain.DataR[0]<0.0001) then
       begin
         Showmessage('Take care that R is larger than 0.0001' + Comment);
         exit;
       end
  else if (DMEnDrain.Code<>'Con') and
       (DMEnDrain.DataR[4]<=DMEnDrain.DataR[3]) then
       begin
         Showmessage('Take care that Db is larger than Dw.' + Comment);
         exit;
       end
  else DataOk:=true;
  if (DMEnDrain.Code<>'Con') and
     (DMEnDrain.DataR[1]=DMEnDrain.DataR[2]) then
  begin
    DMEnDrain.DataR[10]:=0;    //Kb2=0
    DMEnDrain.DataR[11]:=0;    //Kv2=0
  end;
end; {CheckData}
{--------------}

    {Graphics}

{Relative is part of Graphics}
{----------------------------}
procedure Relative;
var  ii : integer;
     XdataRel,YdataRel,ZdataRel : real;
begin

  for ii:=0 to DMEnDrain.NrOfData-1 do
  begin
    XdataRel := LX*(DMEnDrain.Xdata[ii]-MinX)/(MaxX-MinX);
    SetLength (RelXdata,ii+1);
    RelXdata[ii] := PosX1+round(XdataRel);
    YdataRel := LY*(DMEnDrain.Ydata[ii]-MinY)/(MaxY-MinY);
    SetLength (RelYdata,ii+1);
    RelYdata[ii] := PosY2-round(YdataRel)-10;
    ZdataRel := LY*(DMEnDrain.Zdata[ii]-MinY)/(MaxY-MinY);
    SetLength (RelZdata,ii+1);
    RelZdata[ii] := PosY2-round(ZdataRel)-10;
  end;

end;
{---------------}
{end of Relative}


{MaxMin is part of Graphics}
{--------------------------}
procedure MaxMin;
var ii : byte;
begin
  Ymax := 0;
  Xmax := 0;
  Ymin := 1000000;
  Xmin := 1000000;
  for ii:=0 to DmEnDrain.NrOfData-1 do
  begin
    if DMEnDrain.Ydata[ii]>Ymax then Ymax := DMEnDrain.Ydata[ii];
    if DMEnDrain.Xdata[ii]>Xmax then Xmax := DMEnDrain.Xdata[ii];
    if DMEnDrain.Ydata[ii]<Ymin then Ymin := DMEnDrain.Ydata[ii];
    if DMEnDrain.Xdata[ii]<Xmin then Xmin := DMEnDrain.Xdata[ii];
  end;
  Ymax:=1.2*Ymax;
end;
{end of Maxmin}
{-------------}


{Scaling is part of Graphics}
{---------------------------}
procedure Scaling;
var ii : integer;
begin

//  Ymax:=1.1*Ymax;
  FactorY:=1;
  FactorX:=1;

  if (Ymax<0.1) then
  begin
    FactorY:=100;
    for ii:=1 to DMEnDrain.NrOfData do
    begin
        DMEnDrain.Ydata[ii-1]:=FactorY*DMEnDrain.Ydata[ii-1];
        DMEnDrain.Zdata[ii-1]:=FactorY*DMEnDrain.Zdata[ii-1];
    end;
    Ymin:=FactorY*Ymin;
    Ymax:=FactorY*Ymax;
  end else
  if (Ymax<1) then
  begin
    FactorY:=10;
    for ii:=1 to DMEnDrain.NrOfData do
    begin
        DMEnDrain.Ydata[ii-1]:=FactorY*DMEnDrain.Ydata[ii-1];
        DMEnDrain.Zdata[ii-1]:=FactorY*DMEnDrain.Zdata[ii-1];
    end;
    Ymin:=FactorY*Ymin;
    Ymax:=FactorY*Ymax;
  end;

  if (Xmax<0.1) then
  begin
    FactorX:=100;
    for ii:=1 to DMEnDrain.NrOfData do
        DMEnDrain.Xdata[ii-1]:=FactorX*DMEnDrain.Xdata[ii-1];
    Xmin:=FactorY*Xmin;
    Xmax:=FactorX*Xmax;
  end else
  if (Xmax<1) then
  begin
    FactorX:=10;
    for ii:=1 to DMEnDrain.NrOfData do
        DMEnDrain.Xdata[ii-1]:=FactorX*DMEnDrain.Xdata[ii-1];
    Xmin:=FactorX*Xmin;
    Xmax:=FactorX*Xmax;
  end;

  if Ymax<10 then
  begin
    decimY := 1;
    MinY := round (Ymin-0.4);
    MaxY := round (Ymax+0.4);
    ScaleY := MaxY-MinY;
    if ScaleY>10 then ScaleY := (MaxY-MinY) div 2;
  end
  else if Ymax<25 then
  begin
    decimY := 1;
    MinY := 4*round ((Ymin-2)/4);
    MaxY := 4*round ((Ymax+2)/4);
    ScaleY := (MaxY-MinY) div 4;
  end
  else if Ymax<50 then
  begin
    decimY := 1;
    MinY := 5*round ((Ymin-2.5)/5);
    MaxY := 5*round ((Ymax+2.5)/5);
    ScaleY := (MaxY-MinY) div 5;
  end
  else
  begin
    decimY := 0;
    MinY := 10*round ((Ymin-5)/10);
    MaxY := 10*round ((Ymax+5)/10);
    ScaleY := (MaxY-MinY) div 10;
  end;

  if Xmax<10 then
  begin
    decimX := 1;
    MinX := round (Xmin-0.5);
    MaxX := round (Xmax+0.5);
    ScaleX := MaxX-MinX;
  end
  else if Xmax<25 then
  begin
    decimX := 1;
    MinX := 4*round ((Xmin-2)/4);
    MaxX := 4*round ((Xmax+2)/4);
    ScaleX := (MaxX-MinX) div 4;
  end
  else if Xmax<50 then
  begin
    decimX := 1;
    MinX := 5*round ((Xmin-2.5)/5);
    MaxX := 5*round ((Xmax+2.5)/5);
    ScaleX := (MaxX-MinX) div 5;
  end
  else if Xmax<100 then
  begin
    decimX := 0;
    MinX := 10*round ((Xmin-5)/10);
    MaxX := 10*round ((Xmax+5)/10);
    ScaleX := (MaxX-MinX) div 10;
  end
  else if Xmax<250 then
  begin
    decimX := 0;
    MinX := 25*round ((2*Xmin-25)/50);
    MaxX := 25*round ((2*Xmax+25)/50);
    ScaleX := (MaxX-MinX) div 25;
  end
  else if Xmax<500 then
  begin
    decimX := 0;
    MinX := 50*round ((Xmin-25)/50);
    MaxX := 50*round ((Xmax+25)/50);
    ScaleX := (MaxX-MinX) div 50;
  end
  else if Xmax<1000 then
  begin
    decimX := 0;
    MinX := 100*round ((Xmin-50)/100);
    MaxX := 100*round ((Xmax+50)/100);
    ScaleX := (MaxX-MinX) div 100;
  end
  else
  begin
    decimX := 0;
    MinX := 250*round ((2*Xmin-250)/500);
    MaxX := 250*round ((2*Xmax+250)/500);
    ScaleX := (MaxX-MinX) div 250;
  end;

  if (Ymax=0) and (Ymin=0) then Ymax:=1
     else if Ymax=Ymin then
     begin
       Ymin:=0;
       Ymax:=Ymax+1;
     end;

  if ScaleY>10 then
  begin
    ScaleY := 10;
    DecimY := DecimY+1;
  end;
  if ScaleX>10 then
  begin
    ScaleX := 10;
    DecimX := DecimX+1;
  end;
  if ScaleY<5 then
  begin
    ScaleY := 5;
    DecimY := DecimY+1;
  end;
  if ScaleX<5 then
  begin
    ScaleX := 5;
    DecimX := DecimX+1;
  end;

end;
{end of Scaling}
{--------------}


{Legends is part of Graphics}
{---------------------------}
procedure Legends;
begin

  if FactorY=1 then LegendY := 'Watertable height above drain (m)';
  if FactorY=10 then LegendY := 'Watertable height above drain (dm)';
  if FactorY=100 then LegendY := 'Watertable height above drain (cm)';
  if FactorY=1000 then LegendY := 'Watertable height above drain (mm)';
  if FactorX=1 then LegendX := 'Distance from drain (m)';
  if FactorX=10 then LegendX := 'Distance from drain (dm)';
  if FactorX=100 then LegendX := 'Distance from drain (cm)';
  if FactorX=1000 then LegendX := 'Distance from drain (mm)';
  LegendY1 := 'x Darcy equation';
  LegendY2 := 'o Energy balance';
  LegendZ  := '- requested line';
end;

{end of Legends}
{--------------}



end.
